net.i2p.router.tunnel

## Class OutboundGatewayProcessor

- java.lang.Object
- - net.i2p.router.tunnel.OutboundGatewayProcessor

-     class OutboundGatewayProcessor
      extends Object

  Turn the preprocessed tunnel data into something that can be delivered to the first hop in the tunnel. The crypto used in this class is also used by the InboundEndpointProcessor, as it's the same 'undo' function of the tunnel crypto.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `OutboundGatewayProcessor(I2PAppContext ctx, TunnelCreatorConfig cfg)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) static void` | `decrypt(I2PAppContext ctx, byte[] orig, int offset, int length, HopConfig config)` Undo the crypto for a single hop.
    `void` | `process(byte[] orig, int offset, int length)` Since we are the outbound gateway, pick a random IV and wrap the preprocessed data so that it will be exposed at the endpoint.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OutboundGatewayProcessor

          public OutboundGatewayProcessor(I2PAppContext ctx,
                                          TunnelCreatorConfig cfg)

  - ### Method Detail

    - #### decrypt

          static void decrypt(I2PAppContext ctx,
                              byte[] orig,
                              int offset,
                              int length,
                              HopConfig config)

      Undo the crypto for a single hop. This is used by both the outbound gateway (preemptively undoing the crypto peers will add) and by the inbound endpoint.
      Parameters:
        `orig` - original data with an extra 16 byte IV prepended.
        `offset` - index into the array where the extra 16 bytes (IV) begins
        `length` - how much of orig can we write to (must be a multiple of 16). Should always be 1024 bytes.

    - #### process

          public void process(byte[] orig,
                              int offset,
                              int length)

      Since we are the outbound gateway, pick a random IV and wrap the preprocessed data so that it will be exposed at the endpoint.
      Parameters:
        `orig` - original data with an extra 16 byte IV prepended.
        `offset` - index into the array where the extra 16 bytes (IV) begins
        `length` - how much of orig can we write to (must be a multiple of 16). Should always be 1024 bytes.